------------------------------------------------------------------------------------------
-- UIshowEquip file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the equipment window
------------------------------------------------------------------------------------------
function CreateUIShowEpique()	
	local windowWidth = 420;
	local windowHeight = 0;

	UIShowEpique=Turbine.UI.Lotro.GoldWindow(); 
	if(settings["nameAccount"]["account1"]["name"] ~= "")then
		windowHeight = (settings["nameAccount"]["account1"]["nbrAlt"] * 20) + 340;
	else
		windowHeight = 440;
	end
	UIShowEpique:SetSize(windowWidth, windowHeight); 
	UIShowEpique:SetText( Strings.PluginEpiqueWindow1 ); 
	UIShowEpique:SetPosition((Turbine.UI.Display:GetWidth()-UIShowEpique:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowEpique:GetHeight())/2); 

	UIShowEpique.Message=Turbine.UI.Label(); 
	UIShowEpique.Message:SetParent(UIShowEpique); 
	UIShowEpique.Message:SetSize(150,10); 
	UIShowEpique.Message:SetPosition(UIShowEpique:GetWidth()/2 - 75, UIShowEpique:GetHeight() - 20); 
	UIShowEpique.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowEpique.Message:SetText(Strings.PluginText); 
	UIShowEpique:SetZOrder(10);
	UIShowEpique:SetWantsKeyEvents(true);
	UIShowEpique:SetVisible(false);


	------------------------------------------------------------------------------------------
	--- button help
	------------------------------------------------------------------------------------------
	buttonDefineHelp = Turbine.UI.Extensions.SimpleWindow();
	buttonDefineHelp:SetParent( UIShowEpique );
	buttonDefineHelp:SetPosition(windowWidth - 45, 35);
	buttonDefineHelp:SetSize( 20, 20 );
	buttonDefineHelp:SetVisible(true);
	buttonDefineHelp:SetMouseVisible(true);

	centerLabelHelp = Turbine.UI.Label();
	centerLabelHelp:SetParent(buttonDefineHelp);
	centerLabelHelp:SetPosition( 0, 0 );
	centerLabelHelp:SetSize( 20, 20  );
	centerLabelHelp:SetBackground(ResourcePath .. "Help.tga");
	centerLabelHelp:SetZOrder(-1);
	centerLabelHelp:SetMouseVisible(false);

	helpButtonLabel = Turbine.UI.Extensions.SimpleWindow();
	helpButtonLabel:SetParent( UIShowEpique );
	helpButtonLabel:SetPosition (windowWidth - 20, 35);
	helpButtonLabel:SetSize( 180, 30 );
	helpButtonLabel:SetZOrder(10000);
	helpButtonLabel:SetVisible(false);
	helpButtonLabel:SetBackground(ResourcePath .. "/Cadre_180_30.tga");

	centerLabelBLabelHelp = Turbine.UI.Label();
	centerLabelBLabelHelp:SetParent(helpButtonLabel);
	centerLabelBLabelHelp:SetPosition( 2, 2 );
	centerLabelBLabelHelp:SetSize( 176, 26  );
	centerLabelBLabelHelp:SetText( Strings.PluginLabelHelp );
	centerLabelBLabelHelp:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	centerLabelBLabelHelp:SetBackColor( Turbine.UI.Color( .9, .1, .4, .9) );
	centerLabelBLabelHelp:SetZOrder(-1);

	buttonDefineHelp.MouseEnter = function()
		helpButtonLabel:SetVisible(true);
	end

	buttonDefineHelp.MouseLeave = function()
		helpButtonLabel:SetVisible(false);
	end

	buttonDefineHelp.MouseClick = function(sender, args)
		GenerateHelpWindow(2);
		HelpWindow:SetVisible(true);
	end

	------------------------------------------------------------------------------------------
	-- sort player name by alphabetical order
	------------------------------------------------------------------------------------------
	a = {};
    for i in pairs(PlayerDatas) do 
		table.insert(a, i);
	end
    table.sort(a);

	posx = 260;
	posy = 110;

	local SizeOfMap = (- 100);
	SizeOfMap = SizeOfMap + (tonumber(returnNombreBooks()) * 30);
	SizeOfMap = SizeOfMap + (settings["nameAccount"]["account1"]["nbrAlt"] * 20);

	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(UIShowEpique);
	viewport1:SetSize(windowWidth - 45, windowHeight - 130);

	viewport1:SetPosition(10, 50);
	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	viewport1.map=Turbine.UI.Control();
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	viewport1.map:SetSize(windowWidth - 45, SizeOfMap); -- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls
	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left

	textBoxBook = {};

	for n, i in ipairs(a) do 
		if(PlayerDatas[i].align == 1)then
			UIShowEpique.Message=Turbine.UI.Label(); 
			UIShowEpique.Message:SetParent(viewport1.map); 
			UIShowEpique.Message:SetSize(120, 30); 
			UIShowEpique.Message:SetPosition(posx - 220, posy - 96); 
			UIShowEpique.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowEpique.Message:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
			if(i == PlayerName)then
				UIShowEpique.Message:SetForeColor(Turbine.UI.Color.Lime);
				DisplayLabelEpique(i, posx - 250, posy - 88, Strings.PluginAddNewEpique, "AddNew.tga", viewport1.map);
			else
				UIShowEpique.Message:SetForeColor(Turbine.UI.Color.White);
			end
			------------------------------------------------------------------------------------------
			--- cut off the name if too long
			------------------------------------------------------------------------------------------
			longueurName = string.len(i);
			if(longueurName > 13)then
				UIShowEpique.Message:SetText(string.sub(i, 1, 12) .. "...");
			else
				UIShowEpique.Message:SetText(i); 
			end

			for name in pairs(PlayerEpique) do
				if(i == name)then
					--Turbine.Shell.WriteLine(name);
					for book in pairs(PlayerEpique[name]) do
						--Turbine.Shell.WriteLine(book);
						if(book == "volume")then
							for xy = 1, tablelength(PlayerEpique[name].volume) do
								textBoxBook[i] = Turbine.UI.Label();
								textBoxBook[i]:SetParent( viewport1.map );
								textBoxBook[i]:SetSize(300, 40); 
								textBoxBook[i]:SetPosition(posx - 170, posy - 77);
								textBoxBook[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
								textBoxBook[i]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
								if(PlayerEpique[name].volume[xy] ~= nil or PlayerEpique[name].volume[xy] ~= "")then
									textBoxBook[i]:SetText(PlayerEpique[name].volume[xy] .. "  " .. PlayerEpique[name].livre[xy] .. "  " .. PlayerEpique[name].chapitre[xy]);

									text = {};
									text = Split(PlayerEpique[name].volume[xy], " ");

									BookIcon = Turbine.UI.Label();
									BookIcon:SetParent( viewport1.map );
									BookIcon:SetSize(32, 32); 
									BookIcon:SetPosition(posx - 205, posy - 71);
									if(text[2] == "I" or text[2] == "1")then
										BookIcon:SetBackground( 0x41101698 );
									end
									if(text[2] == "II" or text[2] == "2")then
										BookIcon:SetBackground( 0x41101680 );
									end
									if(text[2] == "III" or text[2] == "3")then
										BookIcon:SetBackground( 0x4111F7BA );
									end
									if(text[2] == "IV" or text[2] == "4")then
										BookIcon:SetBackground( 0x4111F7BC );
									end
									if(text[2] == "V" or text[2] == "5")then
										BookIcon:SetBackground( 0x4113B2E7 );
									end
									BookIcon:SetVisible(true);
									BookIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
								end
								textBoxBook[i]:SetForeColor( Turbine.UI.Color.Gold);
								textBoxBook[i]:SetVisible(true);
								textBoxBook[i]:SetMouseVisible(true);


								if(i == PlayerName)then
									textBoxBook[i].MouseClick = function()
										CreateAddNewWindowEpique(xy);
										AltHolicAddnewWindowEpique:SetVisible(true);
									end
								end

								posy = posy + 30;
							end
						end
					end
				end
			end
		end

		posy = posy + 20;
	end

	if(SizeOfMap >= viewport1:GetHeight())then
		-- create the vertical scrollbar for our viewport
		vscroll1=Turbine.UI.Lotro.ScrollBar();
		vscroll1:SetParent(UIShowEpique);
		vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
		vscroll1:SetPosition(windowWidth - 20, 50);
		vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
		vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
		vscroll1:SetMinimum(0);
		vscroll1:SetMaximum(viewport1.map:GetHeight()-viewport1:GetHeight()); -- we will allow scrolling the height of the map-the viewport height
		vscroll1:SetValue(0); -- set the initial value
		-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
		vscroll1.ValueChanged=function()
			viewport1.map:SetTop(0-vscroll1:GetValue());
		end
	end


	ClosingTheWindowEpique();

	UIShowEpique.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			UIShowEpique:SetVisible(false);
			settings["isEpiqueWindowVisible"]["isEpiqueWindowVisible"] = false;
		end
	
		-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
		if ( args.Action == 268435635 ) then
			hudVisible=not hudVisible;
			if hudVisible then
				UIShowEpique:SetVisible(false);
				MainMinimizedIcon:SetVisible(false);
			else
				UIShowEpique:SetVisible(settings.isEpiqueWindowVisible);
				MainMinimizedIcon:SetVisible(true);
			end
		end
	end

end